---
title: Intl.Locale.prototype.maximize()
slug: Web/JavaScript/Reference/Global_Objects/Intl/Locale/maximize
tags:
  - Internationaliztion
  - Intl
  - JavaScript
  - Method
  - Prototype
  - Reference
---
<div>{{JSRef}}</div>

<p><span class="seoSummary">The <strong><code>Intl.Locale.prototype.maximize()</code></strong> method gets the most likely values for the language, script, and region of the locale based on existing values.</span></p>

<div>{{EmbedInteractiveExample("pages/js/intl-locale-prototype-maximize.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><code><em>locale</em>.maximize()</code></pre>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Locale", "Locale")}} instance whose <code>baseName</code> property returns the result of the <a href="https://www.unicode.org/reports/tr35/#Likely_Subtags">Add Likely Subtags</a> algorithm executed against <em>{{jsxref("Locale/baseName", "locale.baseName")}}</em>.</p>

<h2 id="Description">Description</h2>

<p>Sometimes, it is convenient to be able to identify the most likely locale language identifier subtags based on an incomplete langauage ID. The Add Likely Subtags algorithm gives us this functionality. For instance, given the language ID "en", the algorithm would return "en-Latn-US", since English can only be written in the Latin script, and is most likely to be used in the United States, as it is the largest English-speaking country in the world. This functionality is provided to JavaScript programmers via the <code>maximize()</code> method. <code>maximize()</code> only affects the main subtags that comprise the <a href="https://www.unicode.org/reports/tr35/#Language_Locale_Field_Definitions" rel="noopener">language identifier</a>: language, script, and region subtags. Other subtags after the "-u" in the locale indentifier are called extension subtags and are not affected by the <code>maximize()</code> method. Examples of these subtags include {{jsxref("Locale/hourCycle", "Locale.hourCycle")}}, {{jsxref("Locale/calendar", "Locale.calendar")}}, and {{jsxref("Locale/numeric", "Locale.numeric")}}.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_maximize">Using maximize</h3>

<pre class="brush: js">let myLocale = new Intl.Locale("fr", {hourCycle: "h24", calendar: "gregory"});
console.log(myLocale.baseName); // Prints "fr"
console.log(myLocale.toString()); // Prints "fr-u-ca-gregory-hc-h24"
let myLocMaximized = myLocale.maximize();

// Prints "fr-Latn-FR". The "Latn" and "FR" tags are added,
// since French is only written in the Latin script and is most likely to be spoken in France.
console.log(myLocMaximized.baseName);

// Prints "fr-Latn-FR-u-ca-gregory-hc-h24".
// Note that the extension tags (after "-u") remain unchanged.
console.log(myLocMaximized.toString()); </pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ES Int Draft', '#sec-Intl.Locale.prototype.maximize')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Intl.Locale.maximize")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Locale", "Intl.Locale")}}</li>
 <li>{{jsxref("Locale/baseName", "Locale.baseName")}}</li>
 <li><a href="https://www.unicode.org/reports/tr35/#Likely_Subtags">Unicode's Likely Subtags spec</a></li>
</ul>
